Change menu items dynamically in Angular Context Menu

26 Sep 20265 minutes to read

The Angular Context Menu component supports dynamic menu item changes based on the target element where the Angular Context Menu is triggered. This functionality enables context-aware menus that display different options depending on the specific area or element the user interacts with, enhancing user experience through relevant, targeted actions.

To implement dynamic menu items, initialize the Angular Context Menu with a comprehensive set of all possible items using the items property. Then, use the beforeOpen event to selectively show or hide specific items based on the target context. This approach leverages the hideItems and showItems methods to control menu item visibility dynamically.

The beforeOpen event provides access to the target element through its event arguments, allowing you to determine the appropriate menu items to display based on element properties, classes, or other identifying attributes.

In the following example, the menu items change contextually based on the target area: the Clipboard div displays Cut, Copy, and Paste options, while the Editor div shows Add, Edit, and Delete actions. This dynamic behavior is implemented using the hideItems and showItems methods within the beforeOpen event handler.

The beforeOpen event provides the following arguments through BeforeOpenCloseMenuEventArgs:

  • element: The popup element of the ContextMenu.
  • items: The list of MenuItemModel items being rendered.
  • target: The element on which the ContextMenu is being opened.
  • cancel: Set to true to cancel the open.
import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ContextMenuModule } from '@syncfusion/ej2-angular-navigations'
import { enableRipple } from '@syncfusion/ej2-base'



import { Component, ViewChild } from '@angular/core';
import { MenuItemModel, BeforeOpenCloseMenuEventArgs } from '@syncfusion/ej2-navigations';
import { ContextMenuComponent } from '@syncfusion/ej2-angular-navigations';

@Component({
imports: [
        
        ContextMenuModule
    ],


standalone: true,
  selector: 'app-root',
  template: `<div class="e-section-control">
            <!--target element-->
            <div id="target">
              <div id='left' class='e-div'>Clipboard</div>
              <div id='right' class='e-div'>Editor</div>
            </div>
            <!-- To Render ContextMenu. -->
            <ejs-contextmenu #contextmenu target='#target .e-div' [items]= 'menuItems' (beforeOpen)='beforeOpen($event)'></ejs-contextmenu>
            </div>`
})

export class AppComponent {
    @ViewChild('contextmenu')
    public cmenu?: ContextMenuComponent;
    // Initialize menu items.
    public menuItems: MenuItemModel[] = [
    {
        text: 'Cut'
    },
    {
        text: 'Copy'
    },
    {
        text: 'Paste'
    },
    {
        text: 'Add'
    },
    {
        text: 'Edit'
    },
    {
        text: 'Delete'
    }];

    public beforeOpen (args: BeforeOpenCloseMenuEventArgs) {
       // To hide/show items on right click.
        if ((args.event.target as HTMLElement).id === 'right') {
                (this.cmenu as ContextMenuComponent).hideItems(['Cut', 'Copy', 'Paste']);
                (this.cmenu as ContextMenuComponent).showItems(['Add', 'Edit', 'Delete']);
        } else if ((args.event.target as HTMLElement).id === 'left') {
            (this.cmenu as ContextMenuComponent).showItems(['Cut', 'Copy', 'Paste']);
            (this.cmenu as ContextMenuComponent).hideItems(['Add','Edit','Delete']);
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

How to change menu items dynamically in Vue Context Menu

03 Sep 20268 minutes to read

The items visible in the ContextMenu can be changed dynamically based on the target in which you open the ContextMenu. To achieve this behavior, initialize the ContextMenu with all items using the items property and then, based on the context you open, hide/show the required items using the hideItems/ showItems methods in the beforeOpen event.

In the following example, the datasource for the Clipboard div is Cut, Copy, Paste and for the Editor div is Add, Edit, Delete, which is changed on the beforeOpen event using the hideItems and showItems methods.

<template>
    <div>
        <div id="target">
            <div id='left' class='e-div'>Clipboard</div>
            <div id='right' class='e-div'>Editor</div>
        </div>
        <ejs-contextmenu id='cmenu' target='#target' :items='menuItems' :beforeOpen="onBeforeOpen"></ejs-contextmenu>
    </div>
</template>

<script setup>

import { ContextMenuComponent as EjsContextmenu } from "@syncfusion/ej2-vue-navigations";
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);

const menuItems = [
    {
        text: 'Cut'
    },
    {
        text: 'Copy'
    },
    {
        text: 'Paste'
    },
    {
        text: 'Add'
    },
    {
        text: 'Edit'
    },
    {
        text: 'Delete'
    }
];

const onBeforeOpen = (args) => {
    var menuObj = document.getElementById("cmenu").ej2_instances[0];
    // To hide/show items on right click.
    if ((args.event.target).id === 'right') {
        menuObj.hideItems(['Cut', 'Copy', 'Paste']);
        menuObj.showItems(['Add', 'Edit', 'Delete']);
    } else if (args.event.target.id === 'left') {
        menuObj.showItems(['Cut', 'Copy', 'Paste']);
        menuObj.hideItems(['Add', 'Edit', 'Delete']);
    }
};

</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";

#target {
    user-select: none;
}

.e-div {
    width: 40%;
    border: 1px dashed;
    height: 150px;
    margin: 10px;
    text-align: center;
    line-height: 150px;
    display: inline-block;
}
</style>
<template>
    <div>
        <div id="target">
            <div id='left' class='e-div'>Clipboard</div>
            <div id='right' class='e-div'>Editor</div>
        </div>
        <ejs-contextmenu id='cmenu' target='#target' :items='menuItems' :beforeOpen="onBeforeOpen"></ejs-contextmenu>
    </div>
</template>

<script>

import { ContextMenuComponent } from "@syncfusion/ej2-vue-navigations";
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);

export default {
    name: "App",
    components: {
        "ejs-contextmenu": ContextMenuComponent
    },
    data() {
        return {
            menuItems: [
                {
                    text: 'Cut'
                },
                {
                    text: 'Copy'
                },
                {
                    text: 'Paste'
                },
                {
                    text: 'Add'
                },
                {
                    text: 'Edit'
                },
                {
                    text: 'Delete'
                }
            ]
        };
    },
    methods: {
        onBeforeOpen: function (args) {
            var menuObj = document.getElementById("cmenu").ej2_instances[0];
            // To hide/show items on right click.
            if ((args.event.target).id === 'right') {
                menuObj.hideItems(['Cut', 'Copy', 'Paste']);
                menuObj.showItems(['Add', 'Edit', 'Delete']);
            } else if (args.event.target.id === 'left') {
                menuObj.showItems(['Cut', 'Copy', 'Paste']);
                menuObj.hideItems(['Add', 'Edit', 'Delete']);
            }
        }
    }
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";

#target {
    user-select: none;
}

.e-div {
    width: 40%;
    border: 1px dashed;
    height: 150px;
    margin: 10px;
    text-align: center;
    line-height: 150px;
    display: inline-block;
}
</style>

How to change items dynamically in React

04 Sep 20267 minutes to read

The React Context Menu component supports dynamic menu item changes based on the target element where the React Context Menu is triggered. This functionality enables context-aware menus that display different options depending on the specific area or element the user interacts with.

To implement dynamic menu items, initialize the React Context Menu with a comprehensive set of all possible items using the items property. Then, use the beforeOpen event to selectively show or hide specific items based on the target context. This approach leverages the hideItems and showItems methods to control menu item visibility dynamically.

The beforeOpen event provides access to the target element through its event arguments, allowing you to determine the appropriate menu items to display based on element properties, classes, or other identifying attributes.

In the following example, the menu items change contextually based on the target area: the Clipboard div displays Cut, Copy, and Paste options, while the Editor div shows Add, Edit, and Delete actions. This dynamic behavior is implemented using the hideItems and showItems methods within the beforeOpen event handler.

import { enableRipple } from '@syncfusion/ej2-base';
import { ContextMenuComponent } from '@syncfusion/ej2-react-navigations';
import * as React from 'react';
import * as ReactDom from 'react-dom';
enableRipple(true);
function App() {
    let cmenuInstance;
    let menuItems = [
        {
            text: 'Cut'
        },
        {
            text: 'Copy'
        },
        {
            text: 'Paste'
        },
        {
            text: 'Add'
        },
        {
            text: 'Edit'
        },
        {
            text: 'Delete'
        }
    ];
    function beforeOpen(args) {
        if (args.event.target.id === 'right') {
            cmenuInstance.hideItems(['Cut', 'Copy', 'Paste']);
            cmenuInstance.showItems(['Add', 'Edit', 'Delete']);
        }
        else if (args.event.target.id === 'left') {
            cmenuInstance.showItems(['Cut', 'Copy', 'Paste']);
            cmenuInstance.hideItems(['Add', 'Edit', 'Delete']);
        }
    }
    return (<div className="container">
            <div id="target">
                <div id='right' className='e-div'>Editor</div>
                <div id='left' className='e-div'>Clipboard</div>
            </div>
            <ContextMenuComponent id='contextmenu' target='#target' ref={cmenu => cmenuInstance = cmenu} items={menuItems} beforeOpen={beforeOpen}/>
          </div>);
}
export default App;
ReactDom.render(<App />, document.getElementById('element'));
import { enableRipple } from '@syncfusion/ej2-base';
import { BeforeOpenCloseMenuEventArgs } from '@syncfusion/ej2-navigations';
import { ContextMenuComponent, MenuItemModel } from '@syncfusion/ej2-react-navigations';
import * as React from 'react';
import * as ReactDom from 'react-dom';

enableRipple(true);

function App() {
  let cmenuInstance: ContextMenuComponent;
  let menuItems: MenuItemModel[] = [
    {
        text: 'Cut'
    },
    {
        text: 'Copy'
    },
    {
        text: 'Paste'
    },
    {
        text: 'Add'
    },
    {
        text: 'Edit'
    },
    {
        text: 'Delete'
    }];

  function beforeOpen(args: BeforeOpenCloseMenuEventArgs) {
      if ((args.event.target as HTMLElement).id === 'right') {
        cmenuInstance.hideItems(['Cut', 'Copy', 'Paste']);
        cmenuInstance.showItems(['Add', 'Edit', 'Delete']);
      } else if ((args.event.target as HTMLElement).id === 'left') {
        cmenuInstance.showItems(['Cut', 'Copy', 'Paste']);
        cmenuInstance.hideItems(['Add','Edit','Delete']);
      }
  }

  return (
          <div className="container">
            <div id="target">
                <div id='right' className='e-div'>Editor</div>
                <div id='left' className='e-div'>Clipboard</div>
            </div>
            <ContextMenuComponent id='contextmenu' target='#target' ref={cmenu => cmenuInstance = cmenu as ContextMenuComponent}
            items={menuItems} beforeOpen={beforeOpen}/>
          </div>
      );
}
export default App;
ReactDom.render(<App />,document.getElementById('element'));